#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <commdlg.h>

#include <time.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include <stdlib.h>
#include <conio.h>
#include <ctype.h>

#include <string>
#include <vector>
using namespace std;

#define LICENSEKEY "XXXX-XXXX-XXXX-XXXX"
/////////////////////////////////
//If you set bIsRenderToPDF to TRUE, bwPageCount and colorPageCount will return valid values, 
//if you set bIsRenderToPDF to FALSE, bwPageCount will return total pages.
//
//Return value:
//  TRUE is successful
//  FALSE is failed
//
/////////////////////////////////
extern "C" __declspec(dllexport) 
BOOL WINAPI ReadInfoFromAllFormats(LPCTSTR fileName, BOOL bIsRenderToPDF, DWORD* bwPageCount, DWORD* colorPageCount, 
							   DWORD* copyCount, double* pagewidth, double* pageheight, LPTSTR paperSizeName);

extern "C" __declspec(dllexport) 
BOOL WINAPI ReadInfoFromPSFile(LPCTSTR fileName, BOOL bIsRenderToPDF, DWORD* bwPageCount, DWORD* colorPageCount, 
						 DWORD* copyCount, double* pagewidth, double* pageheight, LPTSTR paperSizeName);

extern "C" __declspec(dllexport) 
BOOL WINAPI ReadInfoFromPCLFile(LPCTSTR fileName, BOOL bIsRenderToPDF, DWORD* bwPageCount, DWORD* colorPageCount, 
						 DWORD* copyCount, double* pagewidth, double* pageheight, LPTSTR paperSizeName);

extern "C" __declspec(dllexport) 
BOOL WINAPI ReadInfoFromEMFFile(LPCTSTR fileName, BOOL bIsRenderToPDF, DWORD* bwPageCount, DWORD* colorPageCount, 
								DWORD* copyCount, double* pagewidth, double* pageheight, LPTSTR paperSizeName);

extern "C" __declspec(dllexport) 
BOOL WINAPI ReadInfoFromSPLEMFFile(LPCTSTR fileName, BOOL bIsRenderToPDF, DWORD* bwPageCount, DWORD* colorPageCount, 
								   DWORD* copyCount, double* pagewidth, double* pageheight, LPTSTR paperSizeName);

extern "C" __declspec(dllexport) 
void WINAPI ReadInfoSetCode(const char *lpCode);

extern "C" __declspec(dllexport) 
void WINAPI ReadInfoEnableDebug(int bEnable);

void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}

void DumpInformation(char *lpInFile, BOOL bIsRenderToPDF)
{
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];
	
	_splitpath(lpInFile, drive, dir, fname, ext );
	
	DWORD bwPageCount = 0;
	DWORD colorPageCount = 0;
	DWORD copyCount = 0;
	double nPageWidth = 0;
	double nPageHeight = 0;
	char szPaperSizeName[200] = {0};
	BOOL bRet = FALSE;
	
	ReadInfoSetCode(LICENSEKEY);
	ReadInfoEnableDebug(1);
	if(!stricmp(ext, ".ps") || !stricmp(ext, ".eps"))
		bRet = ReadInfoFromPSFile(lpInFile, bIsRenderToPDF, &bwPageCount, &colorPageCount, &copyCount, &nPageWidth, &nPageHeight, szPaperSizeName);
	else if(!stricmp(ext, ".pcl"))
		bRet = ReadInfoFromPCLFile(lpInFile, bIsRenderToPDF, &bwPageCount, &colorPageCount, &copyCount, &nPageWidth, &nPageHeight, szPaperSizeName);
	else
		bRet = ReadInfoFromAllFormats(lpInFile, bIsRenderToPDF, &bwPageCount, &colorPageCount, &copyCount, &nPageWidth, &nPageHeight, szPaperSizeName);
	printf("=======================================\n");
	printf("File = '%s'\n", lpInFile);
	printf("Return Value = %s\n", bRet?"TRUE":"FALSE");
	printf("bIsRenderToPDF = %d\n", bIsRenderToPDF);
	printf("bwPageCount = %d\n", bwPageCount);
	printf("colorPageCount = %d\n", colorPageCount);
	printf("copyCount = %d\n", copyCount);
	printf("PageWidth = %g\n", nPageWidth);
	printf("PageHeight = %g\n", nPageHeight);
	printf("PaperSizeName = '%s'\n", szPaperSizeName);
	printf("\n\n\n", lpInFile);
}

typedef struct SPLParserTHREADINFOtag{
	char szSPLFile[MAX_PATH];
	int  dwThreadID;
	int  iResult;
}SPLParserTHREADINFO,*LPSPLParserTHREADINFO;
static DWORD WINAPI LaunchSPLParserThread(LPVOID pParam)
{
	LPSPLParserTHREADINFO lpSPLParserInfo = (LPSPLParserTHREADINFO)pParam;
	int nThreadID = GetCurrentThreadId();

	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];
	char *lpInFile = lpSPLParserInfo->szSPLFile;
	
	printf("Thread ID=%d, File=%s\n", nThreadID, lpInFile);
	_splitpath(lpInFile, drive, dir, fname, ext );
	
	BOOL bIsRenderToPDF = TRUE;
	DWORD bwPageCount = 0;
	DWORD colorPageCount = 0;
	DWORD copyCount = 0;
	double nPageWidth = 0;
	double nPageHeight = 0;
	char szPaperSizeName[200] = {0};
	BOOL bRet = FALSE;
	
	ReadInfoSetCode(LICENSEKEY);
	ReadInfoEnableDebug(1);
	if(!stricmp(ext, ".ps") || !stricmp(ext, ".eps"))
		bRet = ReadInfoFromPSFile(lpInFile, bIsRenderToPDF, &bwPageCount, &colorPageCount, &copyCount, &nPageWidth, &nPageHeight, szPaperSizeName);
	else if(!stricmp(ext, ".pcl"))
		bRet = ReadInfoFromPCLFile(lpInFile, bIsRenderToPDF, &bwPageCount, &colorPageCount, &copyCount, &nPageWidth, &nPageHeight, szPaperSizeName);
	else
		bRet = ReadInfoFromAllFormats(lpInFile, bIsRenderToPDF, &bwPageCount, &colorPageCount, &copyCount, &nPageWidth, &nPageHeight, szPaperSizeName);
	printf("ThreadID=%d, =======================================\n", nThreadID);
	printf("File = '%s'\n", lpInFile);
	printf("Return Value = %s\n", bRet?"TRUE":"FALSE");
	printf("bIsRenderToPDF = %d\n", bIsRenderToPDF);
	printf("bwPageCount = %d\n", bwPageCount);
	printf("colorPageCount = %d\n", colorPageCount);
	printf("copyCount = %d\n", copyCount);
	printf("PageWidth = %g\n", nPageWidth);
	printf("PageHeight = %g\n", nPageHeight);
	printf("PaperSizeName = '%s'\n", szPaperSizeName);
	printf("\n\n\n", lpInFile);
	return 0;
}
void TestForMultiThread(char *lpszSPLName)
{
	HANDLE hThreads[150] = {0};
	int nCount = sizeof(hThreads)/sizeof(HANDLE);
	for(int i = 0; i < nCount; i++)
	{
		LPSPLParserTHREADINFO lpSPLParserInfo = new SPLParserTHREADINFO;
		strcpy(lpSPLParserInfo->szSPLFile, lpszSPLName);
		
		DWORD dwThreadId;
		hThreads[i] = CreateThread(NULL,0,LaunchSPLParserThread,lpSPLParserInfo,0,&dwThreadId);
	}
	printf("Press any key to exit the application.");
	_getch();
	//WaitForMultipleObjects(nCount, hThreads, TRUE, INFINITE);
}

void main(int argc, char *argv[])
{
	if(argc != 2)
	{
		printf("%s C:\\test.ps\n", argv[0]);
		printf("%s C:\\test.pcl\n", argv[0]);
		printf("%s C:\\test.spl\n", argv[0]);
		printf("%s C:\\test.pdf\n", argv[0]);
		printf("%s C:\\test.emf\n", argv[0]);
		printf("%s C:\\test.prn\n", argv[0]);
		return;
	}

	char *lpInFile = argv[1];
	if(0)
	{
		TestForMultiThread(lpInFile);
	}
	else if(0)
	{
		DumpInformation(lpInFile, TRUE);
		DumpInformation(lpInFile, FALSE);
	}
	else
	{
		DumpInformation(lpInFile, TRUE);
	}
}
